package edu.mermet.tp8.fenetres;

import edu.mermet.tp8.UserXml;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.ArrayList ;

public class FenetreSuggestion extends JInternalFrame {

    private UserXml user;
    private String afficherPopUp;
    private boolean afficher;
    private ArrayList<String> messages;
    private static final String[] message={"Ctrl+C permet d'ouvrir la fenetre de conversion de degrés",
            "Ctrl+T permet d'ouvrir la fenetre pour saisir du texte",
            "Ctrl+D permet d'ouvrir le diaporama du Cotentin",
            "Ctrl+B permet d'ouvrir la fenetre des boutons",
            "L'option 'Diaporama' permet d'ouvrir un diaporama du Cotentin"};
    private int index;

    private JLabel lblMessage;

    private JPanel conteneurBtn;
    private JButton fermer;
    private JButton nePlusAfficher;

    public FenetreSuggestion(UserXml u){
        super("Suggestion du jour", false, true, false, false);
        user = u;

        afficherPopUp = user.getProperty("afficherPopUp");
        messages = new ArrayList<String>();
        
        if(afficherPopUp.equals("")) {
        	System.out.println("FenetreSuggestion :: La clé 'afficherPopUp' n'existe pas, création...");
            user.setProperty("afficherPopUp", "true");
            afficherPopUp = user.getProperty("afficherPopUp");
            // ajout de tous les messages de suggestions possibles en true
            for(int j=0;j<message.length;j++) {
              messages.add(message[j]);
              user.setProperty(message[j], "true");
            }
            user.save();
        } 
        String pref;
        int j=0; // vérifie si il y a quelque chose à afficher, si il n'y a rien alors la fenêtre est vide
        
        // on rempli la liste des messages exceptés les messages qu'il a spécifié ne pas vouloir voir
        for(int i=0;i<message.length;i++) {
          pref = user.getProperty(message[i]);
          if(!pref.equals("false")) {
            messages.add(message[i]);
            j++;
          }
        }
          
        //afficher = Boolean.parseBoolean(afficherPopUp);
        if(j==0)
          afficher = false;
        else
          afficher = true;
        
        index = (int)(Math.random()*messages.size());
        lblMessage = new JLabel(messages.get(index));
        add(lblMessage, BorderLayout.NORTH);

        conteneurBtn = new JPanel();

        fermer=new JButton(new ActionFermer());
        fermer.setText("Fermer");
        conteneurBtn.add(fermer);

        nePlusAfficher=new JButton(new ActionNePlusAfficher());
        nePlusAfficher.setText("Ne plus afficher");
        conteneurBtn.add(nePlusAfficher);
        add(conteneurBtn, BorderLayout.SOUTH);
        pack();
        setVisible(afficher);
    }

    private class ActionFermer extends AbstractAction{
        public ActionFermer(){
            super("Fermer");
        }
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            setVisible(false);
        }
    }

    // enlève la suggestion que l'on ne veut plus voir
    private class ActionNePlusAfficher extends AbstractAction {
      
        public ActionNePlusAfficher(){
            super("Ne plus afficher");
        }
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            setVisible(false);
            user.setProperty(messages.get(index),"false");
            messages.clear();
            user.save();
        }
    }
}
